package jumpstart.min.business.domain.examples;

import java.util.List;

import javax.ejb.Local;
import javax.ejb.Remote;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import jumpstart.min.business.domain.examples.iface.IExamplesServiceLocal;
import jumpstart.min.business.domain.examples.iface.IExamplesServiceRemote;

@Stateless
@Local(IExamplesServiceLocal.class)
@Remote(IExamplesServiceRemote.class)
public class ExamplesService implements IExamplesServiceLocal, IExamplesServiceRemote {

	@PersistenceContext(unitName = "jumpstart-min")
	protected EntityManager _em;

	// Person

	public Person findPerson(Long id) {
		Person obj = _em.find(Person.class, id);
		return obj;
	}

	@SuppressWarnings("unchecked")
	public List<Person> findPersons() {

		StringBuffer buf = new StringBuffer();
		buf.append("select p from Person p");
		buf.append(" order by p.id");

		Query q = _em.createQuery(buf.toString());
		List l = q.getResultList();

		return l;
	}

	public void changePerson(Person stuff) {
		stuff = _em.merge(stuff);
	}

}
