package jumpstart.min.business.domain.security.iface;

import jumpstart.min.business.commons.exception.BusinessException;
import jumpstart.min.business.domain.security.User;

/**
 * The <code>ISecurityManagerSvcRemote</code> bean exposes the business methods in the interface.
 * 
 * @author Geoff Callender JumpStart
 * @version $Revision: 1.29 $, $Date: 2005/08/21 13:04:12 $
 */
public interface ISecurityManagerSvcRemote {

	/*******************************************************************************************************************
	 * BUSINESS METHODS
	 ******************************************************************************************************************/

	/**
	 * This method provides a way for users to change their own password.
	 */
	void changeUserPassword(Long id, String currentPassword, String newPassword) throws BusinessException;

	/**
	 * This method provides a way for security officers to "reset" the password.
	 */
	void changeUserPassword(Long id, String newPassword) throws BusinessException;

	/*******************************************************************************************************************
	 * PERSISTENCE METHODS
	 ******************************************************************************************************************/

	// User
	User createUser(User user, String password) throws BusinessException;

	void changeUser(User user) throws BusinessException;

	void deleteUser(User user) throws BusinessException;

}
