package jumpstart.min.web.pages.base;

import jumpstart.min.web.pages.login.LoginPage;
import jumpstart.min.web.state.Visit;

import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.PageRedirectException;
import org.apache.tapestry.event.PageEvent;
import org.apache.tapestry.event.PageValidateListener;

/**
 * Base page for pages that must not be accessible if the user is not logged in.
 */
public abstract class ProtectedBasePage extends SimpleBasePage implements PageValidateListener {

	/**
	 * Validate that the user is logged in.  If not logged in, then redirects to the login page.
	 * Tapestry will call this method because this class implements PageValidateListener.
	 * Tapestry calls this method just before showing the page to the user.
	 */
	public void pageValidate(PageEvent event) {

		// If you're not logged in, then we redirect to the login page.
		
		Visit myVisit = getMyVisit();
		if (myVisit == null || !myVisit.isLoggedIn()) {
			IRequestCycle cycle = event.getRequestCycle();
			LoginPage login = (LoginPage) cycle.getPage(LoginPage.PAGE_NAME);
			throw new PageRedirectException(login);
		}

	}

}
