package jumpstart.min.web.pages.examples.tables;

import java.util.List;

import jumpstart.min.business.domain.examples.Person;
import jumpstart.min.business.domain.examples.iface.IExamplesServiceLocal;
import jumpstart.min.web.pages.login.LoginPage;
import jumpstart.min.web.state.BusinessServicesLocator;

import org.apache.tapestry.IAsset;
import org.apache.tapestry.annotations.Asset;
import org.apache.tapestry.annotations.Bean;
import org.apache.tapestry.annotations.InjectState;
import org.apache.tapestry.annotations.Persist;
import org.apache.tapestry.bean.EvenOdd;
import org.apache.tapestry.html.BasePage;

public abstract class AlternatingTablePage extends BasePage {
	static public final String PAGE_NAME = "pages/examples/tables/AlternatingTablePage";

	@Asset("context:/css/examples.css")
	public abstract IAsset getStylesheet();

	@InjectState("businessServicesLocator")
	public abstract BusinessServicesLocator getBusinessServicesLocator();
	
	@Bean
	// Beans get created and destroyed on the fly per request cycle
	public abstract EvenOdd getEvenOdd();

	@Persist
	public abstract void setPersons(List<Person> value);

	public abstract void setPerson(Person value);

	public void activate() {
		// Get all persons - ask business service to find them (from the database)
		IExamplesServiceLocal examplesService = getBusinessServicesLocator().getExamplesServiceLocal();
		List<Person> l = examplesService.findPersons();
		setPersons(l);

		getRequestCycle().activate(this);
	}

	public void doToLogin() {
		LoginPage nextPage = (LoginPage) getRequestCycle().getPage(LoginPage.PAGE_NAME);
		nextPage.activate();
	}
}
